// (c) 2006, 2007 Nerdfever.com

#ifndef __DJLLIB_H
#define __DJLLIB_H

// VARIABLE TYPES

#define INT8	char
#define INT16	int
#define INT24	short long
#define INT32	long

#define UINT8	unsigned INT8
#define UINT16	unsigned INT16
#define UINT24	unsigned INT24
#define UINT32	unsigned INT32

// CONSTANTS

#define	TRUE	(1)
#define FALSE	(0)
#define ON		(1)
#define OFF		(0)
#define HIGH	(1)
#define LOW		(0)
#define EOF		(-1)
#define LF		(0x0a)
#define CR		(0x0d)
#define PI		(3.141592653589793238462)

// MACROS

#define min(a,b)  (((a)>(b))?(b):(a))
#define max(a,b)  (((a)>(b))?(a):(b))
#define between(x,low,high)	(((x)>=(low))&&((x)<=(high)))	// inclusive of ends
#define outside(x,low,high) (((x)< (low))||((x)> (high)))	// ends are inside

// with apologies to Intel (AL, AH, AX, EAX...)
#define BYTE_L(i)	( (UINT8) (i) )
#define BYTE_H(i)   ( (UINT8) ( ((UINT16) (i)) >> 8) )
#define BYTE_EL(i)  ( (UINT8) ( ((UINT24) (i)) >> 16) )
#define BYTE_EH(i)  ( (UINT8) ( ((UINT32) (i)) >> 24) )

#define WORD_L(i)  	( (UINT16) (i) )
#define WORD_H(i)  	( (UINT16) ( ((UINT32) (i)) >> 16) )

#endif // __DJLLIB_H
