// (c) 2006 Nerdfever.com

#ifndef __GLOBALS_H
#define __GLOBALS_H

#include "nmeaGps.h"
#include "hardware.h"
#include "logging.h"

// GLOBALS

extern LOG_ABSOLUTE_GPS_RECORD FixA;
extern LOG_ABSOLUTE_GPS_RECORD FixB;
extern LOG_ABSOLUTE_GPS_RECORD *LastGPSFixPtr;
extern LOG_ABSOLUTE_GPS_RECORD *NextGPSFixPtr;
extern UINT8 ValidFixCount;
extern UINT8 FixCount;
extern LOG_ABSOLUTE_GPS_RECORD LastValidLoggedFix;
extern UINT32 GPSBurstStartRTC;
extern UINT8 DoLogStatus;
extern UINT8 DoLogFix;
extern double DeltaTC;
extern double LaunchThreshold;
extern UINT8 AnyFix;
extern UINT8 PositionFix;
extern UINT16 volatile ServoPulseLengthUTicks;
extern UINT32 volatile RTC;
extern UINT8 Buzzer;
extern UINT8 Horn;
extern UINT8 Beep;
extern UINT16 SwRedHeld;
extern UINT16 SwYellowHeld;
extern UINT16 SwGreenHeld;
extern double SlowTCpressure;
extern double FastTCpressure;
extern double PadPressure;
extern double ApogeePressure;
extern UINT24 Pressure;
extern UINT32 CycleCount;
extern UINT8 LDet;
extern UINT8 ADet;
extern UINT32 IRCode;
extern UINT8 State;
extern UINT8 Substate;
extern char volatile NMEAbuffer[NMEA_LINES][NMEA_BUFSIZE];
extern UINT8 volatile NMEAwriteLine;
extern UINT8 		  NMEAreadLine;
extern UINT8 volatile NMEAlineCount;
extern UINT8 volatile NMEAcharCount;
extern UINT32 LastUARTrxRTC;
extern UINT24 FlashWritePtr;
extern UINT24 FlashFlushPtr;
extern UINT8 FlashBuffer[FLASH_BUFFER_ROWS][FLASH_ROW_SIZE];
extern UINT8 FlashBufferWriteRow;
extern UINT8 FlashBufferWriteCount;
extern UINT8 FlashBufferRowCount;
extern UINT8 FlashBufferFlushRow;
extern UINT8 Dummy;

// Loud horn (smoke alarm horn) stuff
#define FAST_HORN (2)
#define SLOW_HORN (3)

// used with globals
#define MS(ms)		((ms) / RTC_INTERRUPT_INTERVAL_MS)	// milliseconds to rtc ticks
#define SECS(secs)	(MS( (UINT24) (secs) * 1000 ))		// seconds to rtc ticks
#define RTC8 		((UINT8) RTC)						// low 8 bits of RTC
#define RTC16		((UINT16) RTC)						// low 16 bits of RTC
#define	RTC24		((UINT24) RTC)						// low 24 bits of RTC
#define	RTC32		(RTC)								// low 32 bits of RTC

// returns TRUE if the time now (derived from RTC) is >= time "when"
// (to avoid rollover error, use only when possible time offset is within +/- signed range of bit width)
#define YET8(when)	((INT8) (RTC8  - (when)) >= 0)
#define YET16(when)	((INT16)(RTC16 - (when)) >= 0)
#define YET24(when)	((INT24)(RTC24 - (when)) >= 0)
#define YET32(when)	((INT32)(RTC32 - (when)) >= 0)

// returns TRUE if the time now (derived from RTC) is < time "when"
// (to avoid rollover error, use only when possible time offset is within +/- signed range of bit width)
#define NOTYET8(when)	((INT8) (RTC8  - (when)) < 0)
#define NOTYET16(when)	((INT16)(RTC16 - (when)) < 0)
#define NOTYET24(when)	((INT24)(RTC24 - (when)) < 0)
#define NOTYET32(when)	((INT32)(RTC32 - (when)) < 0)

#endif // __GLOBALS_H
