// (c) 2007 Nerdfever.com

#ifndef __PERIPHERALS_H
#define __PERIPHERALS_H

// for pressure sensor Freescale MPX4105A

#define PRESSURE_OVERSAMPLES	(64)		// number of times to oversample ADC
#define PRESSURE_FULLSCALE		((UINT24) 1024 * (PRESSURE_OVERSAMPLES) - (PRESSURE_OVERSAMPLES))
#define Vref_minus				(0.0)		// volts
#define Vref_plus				(Vdd)

#define ReadPressureSensor() 	(AccumulateADCsamples(PRESSURE_OVERSAMPLES))
#define ServiceBuzzer()			if (Buzzer) PIEZO = !PIEZO	// faster than an XOR (slower than a speeding bullet)
#define ServiceBeep()			if (Beep)   PIEZO = !PIEZO	// used to beep out response codes in ISR

INT24 PressureToFeet(double pressure);
void BeepOutMaxAltitude(void);
void ServiceHorn(void);
void PollSwitches(void);
UINT8 EjectionContinuity(void);

#endif // __PERIPHERALS_H
